/*	Sits between a computer motherboard and the control signal of a 4-pin PWM fan and
	sets the fan speed to 100% for <AVR-startup-time> + 20s, after that it just
	starts copying the control signal sent from the computer to the fan.

	This solves the problem where you have replaced the stock fan with a slower spinning
	one and the motherboard fan monitoring is happy with the fan speed when it is up to
	speed, but warns on every power-up because the fan does not spin up quick enough
	with the PWM duty cycle given by the motherboard at powerup.

	Implemented on an ATMega48 and handles two fans, but up to eight can be handled
	by adding more PCINT bits to PCMSK0.

	The reason I did this was that after replacing the stock fans on an old Dell
	Precision 390, I had to press F1 on the keyboard every time the computer was
	started to get past a CPU fan warning. That computer starts with a 0% PWM duty
	cycle and ramps it up very slowly, resulting in a very long startup-time for
	not-so-powerful fans like the noctua one I used.

	By Patrik Axelsson 2013
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

/*ISR (PCINT3_vect)
{
	PORTB = PIND;
}*/

int main(void)
{
	uint8_t i = 0;
	
	DDRD=0x00; //Reläer (ut)
	//DDRA=0xFF; //Knappar (in)
	DDRB = 0x00; //Lysdioder
	DDRC=0xFF;

	PORTC = 0xFF;
	PORTD = 0x00;

	/*DDRD=0xFF;
	_delay_ms(1000);
	DDRD=0x00;
	_delay_ms(1000);
	DDRD = 0xFF;
	_delay_ms(1000);
		
	DDRD=0xFF;
	_delay_ms(1000);
	DDRD=0x00;
	_delay_ms(1000);

	DDRD=0xFF;
	_delay_ms(1000);
	DDRD=0x00;
	_delay_ms(1000);*/


/*en3SecHalfDutyCycle();
	gen3SecHalfDutyCycle();
	gen3SecHalfDutyCycle();

	DDRD=0x00;

	//Pullup of input pins
	PORTB = 0xFF;*/
	//PCIE0 set to scan PCMSK0
	//PCICR |= _BV(PCIE3);
	//Trigger on pin changes on PINB0(PCINT0) and PINB1(PCINT1)     
	//PCMSK3 |= _BV(PCINT28); 
	//PCMSK3 = 0xFF; 

	//Enable interrupts to run the control signal copy
	//sei();	
	//DDRC = ~PINB & (_BV(PIN0) | _BV(PIN1));*/
	uint8_t prevButtons = 0x00;
	uint8_t ledKaka = 0x00;
	for(;;)
	{
		uint8_t buttons = ~PIND;
		/*uint8_t nextButtons = 0x00;
		_delay_ms(5);
		nextButtons = ~PIND;	
		if(buttons == nextButtons && buttons != prevButtons)
		{
			PORTA = PORTA ^ buttons;
			prevButtons = buttons;
		}*/


		ledKaka++;
		DDRB = buttons | (buttons << 1);
		if(buttons == 0x20)
			DDRB |= 0x01;
		PORTB = buttons;
		//_delay_ms(500);

	}

    return 0;
}
